
; Asar directives
hirom
table charset.tbl,rtl


; =============================[ Segment edits ]===============================

; Relocating BRR data at $1480 to $1460
org $C503EC : LDA #$1460
org $C50456 : LDA $1460,X
org $C5045C : LDA $1461,X

; Reset SwdTech names at title screen
org $C0BDE8 : STA $14A0,X
org $C0BDEC : CPX #$0060

; Load SwdTech name in battle
org $C2BB2F : LDA $7E14A0,X

; Set address to SwdTech names for main menu
org $C3532D : LDY #$14A0 ; Source LBs
org $C35332 : LDA #$7E   ; Source HB

; Jump table for field menu commands
org $C30259 : dw C3BE00  ; 3F: Initialize SwdTech naming menu
org $C3025B : dw _3BE37  ; 40: Handle SwdTech naming choice 1
org $C3025D : dw C3BE7A  ; 41: Handle SwdTech naming choice 2
org $C30295 : dw C3652D  ; 5D: Initialize actor naming menu
org $C30299 : dw C3656C  ; 5F: Sustain actor naming menu

org $C314FE ; Load save data on defeat
C314FE:  LDA $021F       ; File number
         BEQ C31514      ; Reset if none
         JSR $1566       ; Load save file
         JSR $19D1       ; Compute checksum
         JSR $19EB       ; Bad checksum?
         BEQ C31514      ; Reset game if so
         JSR $1595       ; Move timer data
         JSR ldtech      ; Move tech names
         TDC             ; Reset game: No
         BRA C31518      ; Set aftereffect
C31514:  LDA #$FF        ; Reset game: Yes
C31518:  STA $0205       ; Set aftereffect
         RTL

warnpc $C3151D : print pc," / C3151D [Game over]"


org $C32A51 ; 23: Sustain load confirmation
         JSR ldtech      ; Move tech names
         JMP fdexit      ; Queue menu exit

warnpc $C32A58 : print pc," / C32A58 [Load menu]"


org $C31533 ; Record game data
         JSR svtech      ; Move tech names

org $C3299B ; Sustain SwdTech menu
C3299B:  JSR tchclk      ; Handle A
         BCS C3299B-14   ; Exit if pushed
         LDA $09         ; Pushing B?
         BPL C3299B-14   ; Exit if not
         NOP

warnpc $C329A5 : print pc," / C329A5 [Sustain SwdTech menu]"


; ===========================[ Actor naming menu ]=============================

org $C3652D

; 5D: Initialize actor naming menu
C3652D:  LDX #$5838      ; A's cursor pos
         JSR inimenu     ; Initialize data
         LDY #C36647     ; C3/6647
         JSR $05FE       ; Load navig data
         JSR C36641      ; Relocate cursor
         LDA #$04        ; Windows: 4
         LDY #C36761     ; C3/6761
         JSR boxes       ; Draw windows

; Fork: Initialize arrow's column
         LDX $0201       ; Actor's address
         STX $67         ; Memorize it
         STZ $28         ; Column: 1st
C36625:  LDA $02,X       ; Current letter
         INC A           ; Terminator?
         BEQ .text       ; Done if so
         INX             ; Point to next
         INC $28         ; Column +1
         LDA $28         ; Column
         CMP #$05        ; On letter 6?
         BNE C36625      ; Loop if not

; Fork: Draw text
.text    LDX #$3B1B      ; Tilemap ptr
         JSR C367BF      ; Draw options
         JSR C3675B      ; Draw actor name
         LDY #C368E3     ; Text pointer
         JSR $02F9       ; Draw "Please..."

; Fork: Create portrait
.next    JSR C3678C      ; Load colors
         LDX $67         ; Actor's address
         TDC             ; Clear A
         LDA $01,X       ; Graphics set			<- Could reuse C3/6EA5
         REP #$20        ; 16-bit A
         ASL A           ; Double it
         TAX             ; Index it
         LDA #$2600      ; $2600
         STA $2116       ; Set VRAM ptr
         LDA.L $C36F1B,X ; GFX pointer
         TAX             ; Index it
         JSR $7000       ; Load graphics
         SEP #$20        ; 8-bit A
         JSR C366D8      ; Create object

; Fork: Create arrow, upload text, etc.
         LDX #$4078      ; Base pos: 120, 64
         JSR qarrow      ; Queue arrow fn
         LDX #$5F01      ; Next: Fade-in
;        STX $26         ; Queue: Sustain menu
         JMP C3BFB_      ; Upload text, etc.		<- Could move closer for BRA

; 5F: Sustain actor naming menu
C3656C:  JSR $0EE9       ; Queue text upload
         JSR C3663E      ; Handle D-Pad
         JSR C3675B      ; Redraw actor name

; Fork: Handle Start
C36575:  LDX $67         ; Actor's address
         LDA $09         ; No-autofire keys
         BIT #$10        ; Pushing Start?
         BEQ C3657_      ; Branch if not
         LDA $02,X       ; First letter
         INC A           ; Terminator?
         BNE C365DB      ; Valid if not
         JMP buzzer      ; Buzzer + Mosaic		<- Could move closer for BEQ
C365DB:  JSR fdexit      ; Queue menu exit		<- Could move closer for BRA if put last
;        STZ $0205       ; Never read...
         JMP $0EB2       ; Sound: Click			<- Could BRA to other one if moved closer

; Fork: Point to current letter in name
C3657_:  LDA $28         ; Arrow column
.loop    INX             ; Address +1
         DEC A           ; Column -1
         BPL .loop       ; Loop till < 0
         TXY             ; Copy to Y

; Fork: Handle A
C3657E:  LDA $08         ; Pushing A?
         BPL C36595      ; Branch if not
         LDA $28         ; Arrow's column
         CMP #$05        ; Rightmost?
         BEQ C36594      ; Branch if so
         INC $28         ; Go right by 1
C36594:  JSR chrpick     ; Chosen letter
         TYX             ; RAM index
         BRA C3659_      ; Add letter

; Fork: Handle B
C36595:  LDA $09         ; Pushing B?
         BPL C365C1      ; Exit if not
         JSR $0EC7       ; Sound: Delete
         LDA $28         ; Arrow's column
         BEQ C365C1      ; Exit if first
         CMP #$05        ; Rightmost?
         BNE C365B5      ; Branch if not
         LDA #$FF        ; Space char
         CMP $01,X       ; Letter 6's blank?
         BEQ C365B5      ; Branch if so
C3659_:  STA $01,X       ; Clear letter 6
         RTS

; Fork: Delete non-sixth letter
C365B5:  LDA #$FF        ; Char: Terminator
         STA $00,X       ; Clear last letter
         DEC $28         ; Move arrow left
C365C1:  RTS

; Create portrait for actor naming menu
C366D8:  JSR $61DA       ; Queue OAM fn
;        LDA #$FF        ; Time: Infinite
;        STA $7E36CA,X   ; Set pose timer
;        TDC             ; Pose: 1st
;        STA $7E36C9,X   ; Set sprite's
         LDA #$10        ; Y: 16
         STA $7E344A,X   ; Set sprite's			<- Could do JSR $2EFF (same approach for every STA)
;        LDA #$10        ; X: 16
         LDY #$0B8C      ; Anim table ptr
setobj:  STA $7E33CA,X   ; Set X-Pos
         REP #$20        ; 16-bit A
         TYA             ; Anim ptr
         STA $7E32C9,X   ; Set sprite's
         SEP #$20        ; 8-bit A
         LDA #$C3        ; Bank: C3			<- Could do JMP to same code
         STA $7E35CA,X   ; Set ptr HB
         RTS

; Draw actor name for actor naming menu
C3675B:  LDY #$3A29      ; Text position
         JMP $34CF       ; Draw actor name

; Load portrait colors for actor naming menu
C3678C:  TDC             ; Clear A			<- Might be removable
         LDY $67         ; Actor's address
         LDA #$10        ; Colors: 16
         STA $E3         ; Set counter
         PEI ($00)       ; RAM index: 0
         JMP $7CF1       ; Load colors

; Window layout for actor naming menu
C36761:  dw $5A57,$1116  ; 24x19 at $5A57 (Options)
         dw $588B,$0505  ; 07x07 at $588B (Portrait)
         dw $5899,$0214  ; 22x04 at $5899 ("Please...")
         dw $599B,$0212  ; 20x04 at $599B (Name)

; Positioned text for actor naming menu			<- Could load unused counterpart in event dialogue
C368E3:  dw $391B : db "Please enter a name.", $00


; ==========================[ SwdTech naming menu ]============================

; Handle click in SwdTech menu
tchclk:  LDA $08         ; Pushing A?
         BPL C3C07D      ; Exit if not
         JSR $BFC2       ; SwdTech in slot
         BMI buzzer      ; Fail if none
         STA $0206       ; Set chosen tech
         LDA #$FF        ; SwdTech renaming
         STA $0205       ; Set next menu
         JSR $0EB2       ; Sound: Click			<- Not present in SFC version
         SEC             ; Disable B button
         JMP fdexit      ; Queue menu exit		<- Could move closer for BRA
buzzer:  JSR $0EC0       ; Play buzzer			<- Could do JMP $1E42
         JMP $305D       ; Pixelate screen

; Compute SwdTech name data index
C3C06E:  TDC             ; Clear A
         LDA $0201       ; SwdTech
         TAX             ; Set counter
         LDA #$F4        ; Text ptr: -12
.loop    CLC             ; Prepare ADC
         ADC #$0C        ; Text ptr +12
         DEX             ; Counter -1
         BPL .loop       ; Loop till < 0
         TAY             ; Index product
C3C07D:  CLC             ; Prepare ADC
         RTS

; 3F: Initialize SwdTech naming menu
C3BE00:  LDX #$6420      ; A's cursor pos
         JSR inimenu     ; Initialize data
         LDA #$03        ; Windows: 3
         LDY #C3C238     ; C3/C238
         JSR boxes       ; Upload windows

; Fork: Copy gauge colors to BG3 range
         LDX #$30B3      ; Src LBs
         LDA #$7E        ; Src HB
         LDY #$3053      ; Dst LBs
         JSR $0F8E       ; Copy palette

; Fork: Draw charge gauge
C3C1F2:  LDA #$30        ; Palette 4
         STA $29         ; Color: Gray
         LDY #C3C244     ; Text pointer
         JSR $02F9       ; Draw gauge
         LDY #$790F      ; Tilemap ptr
         JSR $3519       ; Set fill pos
;        TDC             ; Clear A
         LDA $0201       ; SwdTech number
         INC A           ; Now 1-8
         PHA             ; Memorize it
         TAY             ; Set as counter
         LDA #$F8        ; Filler tile
         JSR $5362       ; Draw filling

; Fork: Draw character set and SwdTech name
         LDX #$3B55      ; Tilemap ptr
         JSR C367BF      ; Draw options
         TDC             ; Blank tile value
         STA $7E3DEF     ; Erase quote mark
         JSR C3C033      ; Draw SwdTech name

; Fork: Draw "Charge <#>"
         LDY #C3C251     ; Text pointer
         JSR $02F9       ; Draw "Charge"
         PLA             ; SwdTech number
         ADC #$B3        ; Convert to text
         STA $7E78DD     ; To tilemap
         LDA #$20        ; Color: User's
         STA $7E78DE     ; To tilemap

; Fork: Build description tilemap
         JSR $A73D       ; Build desc map

; Fork: Load description graphics
C3BFB3:  JSR $A796       ; Clear GFX buffer
         JSR $831A       ; WRAM: 7E/9EC9
         LDY $00         ; VRAM index: 0
.line    STY $ED         ; Memorize it
         STZ $8D         ; Line width: 0
.char    LDA $2180       ; Desc character
         BEQ .up         ; If terminator
         LDY #$0380      ; For line break
         CMP #$01        ; At line break?
         BEQ .line       ; Loop if so
         JSR $A8A9       ; Char number -128
         JSR $A8B1       ; Load graphics
         BRA .char       ; Do next char
.up      JSR $A991       ; Set to upload
         INC $45         ; Unfreeze CGRAM

; Fork: Set to shift BG1 text vertically
         JSR $9497       ; Set up HDMA
         LDY #C3BDF3     ; C3/BDF3
         STY $4352       ; Set CH5 src LBs

; Fork: Initialize cursor data, etc.
         LDX $00         ; Reset list pos
         JSR C3C07F      ; Load navig data
         JSR C3C088      ; Relocate cursor
         LDX #$4001      ; Next: Fade-in
C3BFB_:  STX $26         ; Queue: Choice 1
         JSR $0E28       ; Upload BG1 A+B		<- Could do JMP $1890 (if so, remove JMP $0E52)
         JSR $0E6E       ; Upload BG3 A+B
         JMP $3541       ; BRT:1 + NMI

; 40: Handle SwdTech naming choice 1
_3BE37:  JSR C3C085      ; Handle D-Pad
         LDA $08         ; Pushing A?
         BPL C3BE67      ; Branch if not
         INC $26         ; Next: Choice 2
         LDX #$1B6F      ; Base pos: 111, 27
         JSR qarrow      ; Queue arrow fn
         LDA $4D         ; Cursor column
         STA $28         ; Set altered slot
         LDY #C36647     ; C3/6647
         JSR $05FE       ; Load navig data
         LDX $5D         ; Former list pos
         STX $4D         ; Set cursor pos
         JSR C36641      ; Relocate cursor		<- Could do BRA if done last and moved closer
         JMP $0EB2       ; Sound: Click

; Fork: Handle Start
C3BE67:  LDA $09         ; No-autofire keys
         BIT #$10        ; Pushing Start?
         BEQ C31DD1      ; Exit if not
C3BE6D:  JSR $0EB2       ; Sound: Click
;        STZ $0205       ; Never read...

; Fork: Convert trailing spaces to terminators
         JSR C3C06E      ; Name data index
         ADC #$0B        ; Reach last char
         TAX             ; Index sum
         LDY #$000B      ; Letters: 11
.loop    LDA $14A0,X     ; Current letter
         CMP #$FE        ; Basic space?
         BCC fdexit      ; Done if not
         INC $14A0,X     ; Now a terminator
         DEX             ; Letter index -1
         DEY             ; One less letter
         BNE .loop       ; Loop till first
fdexit:  LDX #$FF00      ; Next: Fade-out		<- Could do JMP $1DCB
         STX $26         ; Queue menu exit
C31DD1:  RTS

; 41: Handle SwdTech naming choice 2
C3BE7A:  JSR C3C033      ; Set to upload name
         JSR C3663E      ; Handle D-Pad

; Fork: Handle Start
C3BEA9:  LDA $09         ; No-autofire keys
         BIT #$10        ; Pushing Start?
         BNE C3BE6D      ; Return if so

; Fork: Handle A
C3BEB1:  LDA $08         ; Pushing A?
         BPL C3BECB      ; Branch if not
         JSR C3C06E      ; Name data index
         ADC $28         ; Add altered slot
         TAY             ; Index sum
         JSR chrpick     ; Chosen letter
         CMP #$C2        ; Quotation mark?
         BNE .swap       ; Retain if not
         LDA #$FE        ; Space char
.swap    STA $14A0,Y     ; Add to name

; Fork: Point to next letter in name
         LDA $28         ; Altered letter
         INC A           ; Point to next
         CMP #$0C        ; Beyond last?
         BNE C3BEC7      ; Branch if not
         TDC             ; Point to char 1
C3BEC7:  STA $28         ; Set return pos
         RTS

; Fork: Handle B
C3BECB:  LDA $09         ; Pushing B?
         BPL C31DD1      ; Exit if not
         JSR $0EA9       ; Sound: Cursor
         DEC $26         ; Next: Choice 1
         LDX $4D         ; Cursor position
;        STX $5D         ; Set for return
         JSR C3C07F      ; Load navig data
         LDA $28         ; Former position
         STA $4D         ; Set cursor column
         DEC $46         ; Disable arrow
         BRA C3C088      ; Relocate cursor

; Load and set to upload renamed SwdTech
C3C033:  JSR C3C06E      ; Name data index
         LDX $00         ; Tilemap index
.loop    LDA $14A0,Y     ; Name letter
         CMP #$FF        ; Terminator?
         BNE .store      ; Retain if not
         DEC A           ; Raw space char
         STA $14A0,Y     ; Replace char
.store   STA $7E3927,X   ; To tilemap
         LDA #$20        ; Color: User's
         STA $7E3928,X   ; To tilemap
         INY             ; Char index +1
         INX             ; Map index +1
         INX             ; Map index +1
         CPX #$0018      ; Done 12 chars?
         BNE .loop       ; Loop if not
         JMP $0EFD       ; Queue upload

; Load navigation data for SwdTech name
C3C07F:  STX $5D         ; Save list pos
         LDY #C3C08E     ; C3/C08E
         JMP $05FE       ; Load navig data

; Load SwdTech names from SRAM block
ldtech:  CLC             ; Mode: Load
         BRA mvtech      ; Skip a line

; Copy event timers and SwdTech names to SRAM block
svtech:  JSR $1586       ; Move timer data
         SEC             ; Mode: Save			<- Always set after preceding call
mvtech:  LDA #$2F        ; Bytes: 48
         PHA             ; Push counter
         PEA $14A0       ; 7E/14A0
         PEA $1CF8       ; 7E/1CF8
         LDA #$22        ; Bytes: 35
         PHA             ; Push counter
         PEA $14D0       ; 7E/14D0
         PEA $1E1D       ; 7E/1E1D
         LDA #$0C        ; Bytes: 13
         PHA             ; Push counter
         PEA $14F3       ; 7E/14F3
         PEA $1E70       ; 7E/1E70
         LDA #$03        ; Blocks: 3
         STA $E0         ; Set counter
.loop    TDC             ; Clear A
         PLY             ; Dst ptr
         PLX             ; Src ptr
         BCS .go         ; If Save mode
         PHX             ; Push ptr B
         TYX             ; X = ptr A
         PLY             ; Y = Ptr B
.go      PLA             ; Block size
         MVN $00,$00     ; Move block
         DEC $E0         ; One less left
         BNE .loop       ; Loop till last
         RTS

; Handle D-Pad for name area in SwdTech naming menu
C3C085:  JSR $072D       ; Handle D-Pad
C3C088:  JSR $0677       ; Set list slot
         LDA #$14        ; Y: 20
         XBA             ; Put in B
         LDA $4D         ; Cursor's slot
         ASL A           ; x2
         ASL A           ; x4
         ASL A           ; x8 pixels
         ADC #$68        ; Add base X-Pos
         BRA C3664_      ; Set cursor pos

; Navigation data for name in SwdTech naming menu
C3C08E:  db $01          ; Wraps horizontally
         db $00          ; Initial column
         db $00          ; Initial row
         db $0C          ; 12 columns
         db $01          ; 1 row

; BG1 V-Shift table for SwdTech naming menu
C3BDF3:  db $4F,$04,$00  ; SwdTech name
         db $01,$FC,$FF  ; Options
         db $00          ; End

; Window layout for SwdTech naming menu
C3C238:  dw $588B,$021C  ; 30x04 at $588B (Name)
         dw $598B,$041C  ; 30x06 at $598B (Desc)
         dw $5B0B,$0E1C  ; 30x16 at $5B0B (Options)

; Positioned text for SwdTech naming menu
C3C244:  dw $790D : db "",$00
C3C251:  dw $78CF : db "Charge",$00


; ==============================[ Shared code ]================================

; Handle D-Pad for font area
C3663E:  JSR $072D       ; Handle D-Pad
C36641:  JSR $0677       ; Set list slot
         REP #$20        ; 16-bit A
         LDA $4D         ; Cursor position
         XBA             ; Swap X and Y
         ASL A           ; x2
         CMP #$0A00      ; Past middle?
         XBA             ; Swap X and Y
         BCC .left       ; Branch if not
         INC A           ; X-Pos +1 (8 px)
.left    ASL A           ; x4
         ASL A           ; x8
         ASL A           ; x16 pixels
         ADC $FC         ; Add base pos
         SEP #$20        ; 8-bit A
C3664_:  STA $55         ; Set cursor's X
         XBA             ; Y position
         STA $57         ; Set cursor's Y
         RTS

; Initialize menu data					<- Could add 2 entry points with various PEAs (text ptr, nav ptr, window ptr, etc.)
inimenu: STX $FC         ; Set A's cursor pos
         JSR $352F       ; Reset/Stop stuff
         JSR $6904       ; Reset BGs' X/Y
         LDA #$02        ; Main cursor: On
         STA $46         ; Bar/Blinker: Off
         JSR $07B0       ; Queue cursor OAM
         JSR $6A15       ; Clear BG1 map A
         JSR $6A28       ; Clear BG2 map A
         JMP $6A3C       ; Clear BG3 map A

; Draw character options				<- Could integrate into function above
C367BF:  STX $EB         ; Set dst LBs
         LDA #$7E        ; Bank: 7E
         STA $ED         ; Set dst HB
         LDX $00         ; ROM index: 0
         TXY             ; RAM index: 0
         LDA #$07        ; Rows left: 7
C367B_:  PHA             ; Save counter
C367C7:  LDA #$0A        ; Columns: 10
C367C_:  PHA             ; Save counter

; Fork: Add character to tilemap
C367CD:  JSR fntchr      ; Font character
         STA [$EB],Y     ; Set tile number
         INY             ; RAM index +1
         JSR $C2F2       ; Color: User's
         STA [$EB],Y     ; Set attributes
         XBA             ; Put in B
         INX             ; ROM index +1
         INY             ; RAM index +1
         INY             ; RAM index +1
         INY             ; RAM index +1
         PLA             ; Columns left
         CMP #$06        ; At separator?
         BNE C36827      ; Branch if not
         INY             ; RAM index +1
         INY             ; RAM index +1
C36827:  DEC A           ; One less column
         BNE C367C_      ; Loop till last
         LDA #$56        ; Loop counter
.loop    INY             ; RAM index +1
         DEC A           ; Counter -1
         BNE .loop       ; Loop till 0
         PLA             ; Rows left
         DEC A           ; One less left
         BNE C367B_      ; Loop till last
C3682_:  RTS

; Get clicked font character, play sound
chrpick: JSR $0EB2       ; Sound: Click
         TDC             ; Clear A			<- Could do JSR $B2EC/$BFC2
         LDA $4B         ; Selected slot
         TAX             ; Index sum
fntchr:  LDA $D8E8C8,X   ; Chosen letter
         RTS

; Create small arrow
qarrow:  STX $FE         ; Set base pos
         INC $46         ; Show arrow: Y
         LDA #$02        ; Min slot: 16
         LDY #C368A3     ; C3/68A3
         JMP $1173       ; Queue arrow OAM

; Update small arrow
C368A3:  BNE C368CB      ; If mode 1

; Mode 0: Initialize arrow
C368AB:  LDY #$B452      ; Anim table ptr
         JSR setobj      ; Set object data
         JSR $1206       ; Set pose timer
         LDA $FF         ; Y position
         STA $344A,X     ; Set arrow's Y
         INC $3649,X     ; Mode +1

; Mode 1: Sustain arrow
C368CB:  LDA $46         ; Menu flags
         LSR A           ; Delete arrow?
         BCC C3682_      ; Dequeue if so
         LDA $28         ; Arrow's slot
         ASL A           ; x2
         ASL A           ; x4
         ASL A           ; x8 pixels
         ADC $FE         ; Add base X-Pos
         STA $33CA,X     ; Set arrow's X
         JMP $B31E       ; Set OAM; requeue		<- Could do JMP $07F3 if STA $344A,X were moved here

; Draw and upload multiple menu windows
boxes:   PHA             ; Save counter
         PHY             ; Save index
         JSR $0341       ; Draw a window
         PLY             ; Window index
         INY             ; Index +1
         INY             ; Index +1
         INY             ; Index +1
         INY             ; Index +1
         PLA             ; Windows left
         DEC A           ; One less left
         BNE boxes       ; Loop till last
         JMP $0E52       ; Upload windows

warnpc $C368FA : print pc," / C368FA [Both naming menus]"


org $C3B45C

; Navigation data for font area
C36647:  db $00          ; Wraps on all sides
         db $00          ; Initial column
         db $00          ; Initial row
         db $0A          ; 10 columns
         db $07          ; 7 rows
